#include <iostream>
#include <string>

//------------------------------------
// #include <ext/ptr.hpp>
#include "ptr.hpp"
//------------------------------------

using namespace std;

struct Nodo;
//typedef Nodo* PNodo;
typedef Ptr<Nodo> PNodo;
struct Nodo {
	string nombre;
	PNodo sig;
};
//--------------------------------------------------------------------------
void check_1()
{
	PNodo ptr = NULL;
	cout << "ERROR: liberar ptr nulo ["<<(__LINE__+1)<<"]"<< endl;
	delete ptr;
}
void check_2()
{
	PNodo ptr;
	cout << "ERROR: liberar ptr no inicializado ["<<(__LINE__+1)<<"]"<< endl;
	delete ptr;
}
void check_3()
{
	PNodo ptr = new Nodo;
	delete ptr;
	cout << "ERROR: liberar ptr ya liberado ["<<(__LINE__+1)<<"]"<< endl;
	delete ptr;
}
void check_4()
{
	PNodo ptr;
	cout << "ERROR: utilizacion de ptr no inicializado ["<<(__LINE__+1)<<"]"<< endl;
	cout << (ptr == NULL) << endl;
}
void check_5()
{
	PNodo ptr = new Nodo;
	delete ptr;
	cout << "ERROR: utilizacion de ptr ya liberado ["<<(__LINE__+1)<<"]"<< endl;
	cout << (ptr == NULL) << endl;
}
void check_6()
{
	PNodo ptr = NULL;
	cout << "ERROR: desref ptr nulo ["<<(__LINE__+1)<<"]"<< endl;
	cout << ptr->nombre << endl;
}
void check_7()
{
	PNodo ptr;
	cout << "ERROR: desref ptr no inicializado ["<<(__LINE__+1)<<"]"<< endl;
	cout << ptr->nombre << endl;
}
void check_8()
{
	PNodo ptr = new Nodo;
	delete ptr;
	cout << "ERROR: desref ptr ya liberado ["<<(__LINE__+1)<<"]"<< endl;
	cout << ptr->nombre << endl;
}
void check_9()
{
	PNodo ptr = new Nodo;
	cout<<"ERROR: pierde la referencia ["<<(__LINE__+1)<<"]"<< endl;
}
void check_10()
{
	PNodo ptr = new Nodo;
	cout << "ERROR: pierde la referencia ["<<(__LINE__+1)<<"]"<< endl;
	ptr = NULL;
}
void check_11()
{
	PNodo ptr = new Nodo;
	ptr->sig = new Nodo;
	cout << "ERROR: pierde la referencia ["<<(__LINE__+1)<<"]"<< endl;
	delete ptr;
}
void check_12()
{
	PNodo ptr;
	cout << "ERROR: copia de ptr no inicializado ["<<(__LINE__+1)<<"]"<< endl;
	PNodo aux = ptr;
}
void check_13()
{
	PNodo ptr = new Nodo;
	delete ptr;
	cout << "ERROR: copia de ptr ya liberado ["<<(__LINE__+1)<<"]"<< endl;
	PNodo aux = ptr;
}
//-------------------------------------------------------------------------
int main()
{
	int num = 0;
	cout << "Introduzca número de comprobación (del 1 al 13 ambos inclusive): ";
	cin >> num;
	switch (num) {
	case 1:	check_1();	break;
	case 2: check_2();	break;
	case 3: check_3();	break;
	case 4: check_4();	break;
	case 5: check_5();	break;
	case 6: check_6();	break;
	case 7: check_7();	break;
	case 8: check_8();	break;
	case 9: check_9();	break;
	case 10: check_10();	break;
	case 11: check_11();	break;
	case 12: check_12();	break;
	case 13: check_13();	break;
	default:
		cout << "Numero introducido erróneo" << endl;
	}
}
//-------------------------------------------------------------------------
